#!/bin/sh 
set -x


if [ $# -le 4 ]
then
  echo "usage: $0 host src_dir \"filename regexp\" dest_dir [type subtype]"
  exit 1
fi
srchost=$1
srcdir=$2
files=$3
destdir=$4
type=$5
subtype=$6

echo "$srcdir $files $destdir"


if [ ! -w $destdir ]
then
   mkdir -p $destdir
fi

if [ ! -w $destdir ]
then
  echo "$0: cannot write into $destdir"
  exit 1
fi


mkdir /tmp/$$

ftp -vn $srchost <<GETDIR 
user anonymous dbnet@ncodas
bin
prompt
cd $srcdir
dir .  /tmp/$$/dirlist.1
bye
GETDIR

echo $files > /tmp/$$/regex
egrep -f /tmp/$$/regex /tmp/$$/dirlist.1 > /tmp/$$/dirlist.2 


awk '{print $9}' < /tmp/$$/dirlist.2 > /tmp/$$/dirlist.3   
#dirlist=`cat /tmp/$$/dirlist.3`

# Commented out since dirlist.3 is accurate when pulling from gp12
# Copy dirlist.3 to remote_files to keep rest of logic in place
# 08/29/06 - JLC

#for file in $dirlist; do
#   basename $file >> /tmp/$$/remote_files
#done

cp /tmp/$$/dirlist.3 /tmp/$$/remote_files

cd $destdir
ls | egrep -f /tmp/$$/regex > /tmp/$$/local_files
diff  /tmp/$$/remote_files /tmp/$$/local_files > /tmp/$$/diff

grep "<" /tmp/$$/diff | awk '{print $2}' > /tmp/$$/missing

echo "user anonymous dbnet@ncodas" >> /tmp/$$/get_script
echo "bin" >> /tmp/$$/get_script
echo "cd $srcdir" >> /tmp/$$/get_script
echo "lcd $destdir" >> /tmp/$$/get_script

missing=`cat /tmp/$$/missing`
for file in $missing; do
  echo "get $file" >> /tmp/$$/get_script
  [[ -n $type ]] && echo "$DBNROOT/bin/dbn_alert $type $subtype get_missing_files $destdir/$file"  >> /tmp/$$/alert_script 
done

echo "bye" >> /tmp/$$/get_script

#cat /tmp/$$/get_script
chmod 775 /tmp/$$/get_script
ftp -vn $srchost < /tmp/$$/get_script
if [[ -n $type ]]; then
    chmod 775 /tmp/$$/alert_script
   /tmp/$$/alert_script
fi
rm -r /tmp/$$
 
